%bcond_without tests

Summary:        oneAPI Deep Neural Network Library
Name:           onednn
Version:        3.0.1
Release:        4%{?dist}
License:        Apache-2.0 and BSD-2-Clause and BSD-3-Clause and BSL-1.0 and MIT
URL:            https://github.com/oneapi-src/oneDNN/
Source0:        %{url}/archive/v%{version}/onednn-%{version}.tar.gz
Patch3000:      aarch64-gcc13.patch
Patch3001:	3001-oneDNN-3.0.1-add-loongarch-support.patch
BuildRequires:  make cmake gcc-c++
BuildRequires:  doxygen pkgconfig(OpenCL)
Provides: mkldnn = %{version}-%{release}
Provides: mkl-dnn = %{version}-%{release}
Provides: oneDNN = %{version}-%{release}

ExclusiveArch:  x86_64 aarch64 ppc64le riscv64 loongarch64


%description
oneAPI Deep Neural Network Library (oneDNN) is an open-source cross-platform performance library 
of basic building blocks for deep learning applications. oneDNN, part of oneAPI, is optimized for 
Intel(R) Architecture Processors, Intel Graphics, processors based on Arm* 64-bit Architecture 
(AArch64). oneDNN supports NVIDIA* GPU, OpenPOWER* Power ISA (PPC64), RISC-V and other architectures.

oneDNN is designed for deep learning applications and framework developers interested in improving 
application performance on Intel CPUs and GPUs.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
This package provides libraries and header files for developing applications that use %{name}.


%prep
%autosetup -p1 -n oneDNN-%{version}


%build
%cmake
%cmake_build


%install
%cmake_install

rm -rf %{buildroot}%{_docdir}/dnnl


%{?with_tests:
%check
%ctest
}


%files
%license LICENSE THIRD-PARTY-PROGRAMS
%doc README.md CONTRIBUTING.md CODE_OF_CONDUCT.md
%{_libdir}/libdnnl.so.3
%{_libdir}/libdnnl.so.3.*


%files devel
%dir %{_includedir}/oneapi
%{_includedir}/oneapi/dnnl
%{_includedir}/dnnl*.h*
%{_libdir}/libdnnl.so
%dir %{_libdir}/cmake/dnnl
%{_libdir}/cmake/dnnl/*.cmake


%changelog
* Mon May 20 2024 Huang Yang <huangyang@loongson.cn> - 3.0.1-4
- [Type] other
- [DESC] add loongarch support

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.1-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.1-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 11 2023 Wang Guodong <gordonwwang@tencent.com> - 3.0.1-1
- initial build
